]> git.pld-linux.org Git - packages/rpm-build-macros.git/blame - rpm.macros
- 1.437: make sure ghome macros end shell command
[packages/rpm-build-macros.git] / rpm.macros
CommitLineData
397b586d 1# $Revision$, $Date$
415f4a1a 2# PLD Linux rpm macros
d54662bf 3
e05017c1 4%epoch 0
3241033b 5%x8664 x86_64 amd64 ia32e
9c404149 6
ba1fdedc 7# kernel compiler
345d14e5 8%kgcc %{__cc}
d2e1bc22 9%kgcc_package gcc
ba1fdedc 10
36eccf0d
ER
11%__rm /bin/rm --interactive=never
12
33040789 13# Build system path macros.
14#
bddadece
JB
15%__autoconf autoconf %{?debug:-Wall}
16%__automake automake -a -c -f --foreign
f93109a0 17%__autopoint autopoint --force
18
83094b62 19%__gettextize { \
8a995cff 20 if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
3241033b 21 gettextize --copy --force --no-changelog; \
97589b6e 22 else \
3241033b 23 gettextize --copy --force --no-changelog --intl; \
8a995cff
JB
24 fi; \
25 if [ ! -f po/Makevars ]; then \
3241033b 26 cp -f po/Makevars{.template,}; \
8a995cff 27 fi; \
8a995cff 28}
f93109a0 29
30%__glib_gettextize glib-gettextize --copy --force
31%__gnome_doc_common gnome-doc-common --copy
fb59e475 32%__gnome_doc_prepare gnome-doc-prepare --copy --force
f93109a0 33%__gtkdocize gtkdocize --copy
34%__intltoolize intltoolize --copy --force
35%__libtoolize libtoolize --copy --force
33040789 36
384e1b2b 37# Path to top of build area.
81913009 38%_topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)
384e1b2b 39
81e450f7
ER
40# The number of cvs changelog entries kept when building package.
41%_buildchangelogtruncate 20
42
6a5eda77 43%dependencytracking %{nil}
3241033b 44
e5da9169
ER
45# Relations between package names that cause dependency loops
46# with legacy packages that cannot be fixed. Relations are
47# specified as
48# p>q
49# where package p has a Requires: on something that package q Provides:
50#
51# XXX Note: that there cannot be any whitespace within the string "p>q",
52# and that both p and q are package names (i.e. no version/release).
53%_dependency_whiteout %{nil}
54
7bf0526c
AM
55%_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
56 && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
57 [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
810fa5c4 58
59#-----------------------------------------------------------------
60#
61# (re)definition of %{rpm*flags} with %filterout_* support
b5e977c5
ER
62# BuildRequires: awk
63# BuildRequires: rpmbuild(macros) >= 1.315
810fa5c4 64#
65# Flags specified in %filterout_* are removed from %rpm*flags, exactly:
09a90176 66# %rpmcflags = %optflags - %filterout - %filterout_c - %filterout_ld
67# %rpmcxxflags = %optflags - %filterout - %filterout_cxx - %filterout_ld
68# %rpmldflags = %optldflags - %filterout_ld
810fa5c4 69#
70# Regular expressions are supported, but to avoid some character be treated
71# as regular expression it must be escaped twice.
72
73%filter_out \
7b6f1112 74 for (i = 1; i in I; i++) { A=0; \
810fa5c4 75 for (f in F) { \
76 if (I[i] ~ "^" F[f] "$") A=1; \
77 }; \
78 if (!A) printf(I[i] FS); \
79 }
80
81%rpmcflags %(awk 'BEGIN {
82 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
09a90176 83 split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
810fa5c4 84 %{filter_out}
85}')
86
87%rpmcxxflags %(awk 'BEGIN {
09a90176 88 split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
89 split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
810fa5c4 90 %{filter_out}
91}')
92
93%rpmldflags %(awk 'BEGIN {
c05a0741 94 split("%{?optldflags}",I);
810fa5c4 95 split("%{?filterout_ld}",F)
96 %{filter_out}
97}')
98
25f52d1a 99# rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
100# but, don't use it, better use gcc as linker
101%ld_rpmldflags %(awk 'BEGIN {
102 split("%{rpmldflags}",F);
103 for (f in F) {
104 s = F[f];
105 if (s ~ /^-Wl,/) {
106 s = substr(s,5);
107 gsub(/,/," ",s);
108 };
109 printf(s FS);
110 };
111}')
112
9c404149 113#-----------------------------------------------------------------
9f4ce098 114%configure2_13 { \
9c404149
AM
115 if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
116 LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
117 CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
f4cc8832 118 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
9c404149 119 FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
e9d801f4 120 FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
8ec1a12b 121 CPPFLAGS="${CPPFLAGS:-}" ; export CPPFLAGS ; \
8983c4c4
AM
122 %{?__cc:CC="%{__cc}" ; export CC ; } \
123 %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
8f74418b 124 %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
2a7cfd3f 125 --host=%{_target_platform} \
9c404149
AM
126 --prefix=%{_prefix} \
127 --exec-prefix=%{_exec_prefix} \
128 --bindir=%{_bindir} \
129 --sbindir=%{_sbindir} \
130 --sysconfdir=%{_sysconfdir} \
131 --datadir=%{_datadir} \
132 --includedir=%{_includedir} \
133 --libdir=%{_libdir} \
134 --libexecdir=%{_libexecdir} \
135 --localstatedir=%{_localstatedir} \
136 --sharedstatedir=%{_sharedstatedir} \
137 --mandir=%{_mandir} \
138 --infodir=%{_infodir} \
b6c5da52 139 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 140 %{dependencytracking} \
9c404149
AM
141}
142
89f4ca1f
ER
143# override __cmake to add -j4 in your ~/.rpmmacros for parallel make
144%__cmake /usr/bin/cmake
39b9534b
ER
145%cmake { \
146CC="%{__cc}" \
147CXX="%{__cxx}" \
148CFLAGS="%{rpmcflags}" \
149CXXFLAGS="%{rpmcxxflags}" \
89f4ca1f
ER
150%{__cmake} \
151}
152
153# override __scons to add -j4 in your ~/.rpmmacros for parallel make
154%__scons /usr/bin/scons
155%scons { \
156%{__scons} \
5c76736d
ER
157 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
158 CFLAGS="${CFLAGS:-%rpmcflags}" \
159 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
160 FFLAGS="${FFLAGS:-%rpmcflags}" \
161 CPPFLAGS="${CPPFLAGS:-}" \
162 %{?__cc:CC="%{__cc}"} \
163 %{?__cxx:CXX="%{__cxx}"} \
164 libsuffix=%{_lib} \
165 prefix=%{_prefix} \
39b9534b
ER
166}
167
6339d32d 168# waf. see waf.spec
89f4ca1f 169# override __waf to add -j4 in your ~/.rpmmacros for parallel make
6339d32d
ER
170%__waf /usr/bin/waf
171%waf { \
6339d32d
ER
172CC="%{__cc}" \
173CXX="%{__cxx}" \
9e244007 174CPP="%{__cpp}" \
6339d32d
ER
175CFLAGS="%{rpmcflags}" \
176CXXFLAGS="%{rpmcxxflags}" \
177%{__waf} \
6339d32d
ER
178}
179
4a6b0d54 180#----------------------------------------------------------------
9bacbb5b 181#%configure_cache 0
fe6c4bdd 182%configure_cache_file %{buildroot}.configure.cache
73f832b3 183
57f4166d 184%configure {./configure \
4a6b0d54
AF
185 LDFLAGS="${LDFLAGS:-%rpmldflags}" \
186 CFLAGS="${CFLAGS:-%rpmcflags}" \
f4cc8832 187 CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
4a6b0d54 188 FFLAGS="${FFLAGS:-%rpmcflags}" \
e9d801f4 189 FCFLAGS="${FCFLAGS:-%rpmcflags}" \
a2bd5992 190 CPPFLAGS="${CPPFLAGS:-}" \
8983c4c4
AM
191 %{?__cc:CC="%{__cc}"} \
192 %{?__cxx:CXX="%{__cxx}"} \
8e4cb85a 193 --host=%{_target_platform} \
4a6b0d54
AF
194 --build=%{_target_platform} \
195 --prefix=%{_prefix} \
196 --exec-prefix=%{_exec_prefix} \
197 --bindir=%{_bindir} \
198 --sbindir=%{_sbindir} \
199 --sysconfdir=%{_sysconfdir} \
200 --datadir=%{_datadir} \
201 --includedir=%{_includedir} \
202 --libdir=%{_libdir} \
203 --libexecdir=%{_libexecdir} \
204 --localstatedir=%{_localstatedir} \
205 --sharedstatedir=%{_sharedstatedir} \
206 --mandir=%{_mandir} \
207 --infodir=%{_infodir} \
b6c5da52 208 --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
93059874 209 %{dependencytracking} \
9bacbb5b 210 %{?configure_cache:--cache-file=%{configure_cache_file}} \
4a6b0d54
AF
211}
212
b3b1397b
ER
213# overload to insert debuginfo package
214%prep \
215%if 0%{?_enable_debug_packages}\
216%{debug_package}\
217%endif\
218%%prep\
219%{nil}
220
9c404149
AM
221# Location of autoconf macros
222%_aclocaldir %(aclocal --print-ac-dir)
223
e2804f99
AM
224# Location of omf files
225%_omf_dest_dir %(scrollkeeper-config --omfdir)
226
e987a186 227# Location of pkgconfig files
9a4e877a 228%_pkgconfigdir /usr/%{_lib}/pkgconfig
e987a186 229
486b0b5f 230# Location of desktop files
231%_desktopdir /usr/share/applications
86dff2d0 232%_applnkdir ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
486b0b5f 233
481463e9 234# Location of pixmaps for applnk/desktop files
e1f0a822 235%_pixmapsdir /usr/share/pixmaps
9c404149 236
481463e9 237# Location of themable icons for applnk/desktop files
b36c8e2a 238%_iconsdir /usr/share/icons
239
e987a186
JB
240# Location of fonts directories
241%_fontsdir /usr/share/fonts
242
b3282f3f 243# Location of Gtk and associated libraries documentation
fe6c4bdd 244%_gtkdocdir %{_defaultdocdir}/gtk-doc/html
b3282f3f 245
fc4d7771 246# Location of KDE documentation
fe6c4bdd 247%_kdedocdir %{_defaultdocdir}/kde/HTML
fc4d7771 248
5869828c 249# unsermake script
250%__unsermake /usr/share/unsermake/unsermake
251
9c404149
AM
252# Current date
253%date %(LC_ALL="C" date +"%a %b %d %Y")
254
03e0316b
ER
255# tmp directory
256%tmpdir %(echo "${TMPDIR:-/tmp}")
257
9c404149
AM
258# Example files, programs, scripts...
259%_examplesdir /usr/src/examples
260
c8f7e820 261# Alternative kernel type/version
261729d9 262%_alt_kernel %{nil}%{?alt_kernel:-%{?alt_kernel}}
c8f7e820 263
8377d27d 264# The directory holding Linux kernel sources
261729d9 265%_kernelsrcdir /usr/src/linux%{_alt_kernel}
8377d27d 266
9c404149 267# If non-empty "debug" macro defined, add "dbg" suffix to release number
8f74418b 268%_rpmfilename %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
9c404149 269
8f74418b 270# Requires name = version-release
d514eecd 271%requires_releq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
8bf3719d 272
d514eecd
ER
273%releq_kernel() %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
274%releq_kernel_up() %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
275%releq_kernel_smp() %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})
730239f9
ER
276%requires_releq_kernel(s:) Requires%{-s:(%{-s*})}: %releq_kernel
277%requires_releq_kernel_up(s:) Requires%{-s:(%{-s*})}: %releq_kernel_up
278%requires_releq_kernel_smp(s:) Requires%{-s:(%{-s*})}: %releq_kernel_smp
8bf3719d 279
d514eecd
ER
280# XXX: why epoch 0 is stripped?
281%requires_eq() %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
282%requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
01a9f990 283
c0b2771b 284%apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)
b9d5d440 285
286# kernel version-release handling
d33b74f9 287%__kernel_ver %( VER_H=%{_kernelsrcdir}/include/linux/utsrelease.h; [ -f $VER_H ] || VER_H=%{_kernelsrcdir}/include/linux/version.h; [ -f $VER_H ] && (grep UTS_RELEASE $VER_H 2>/dev/null | head -n 1 | cut -d'"' -f2) || (awk '/^VERSION/ { ver = $0; gsub(/VERSION.*=/, NIL, ver); } /^PATCHLEVEL/ { plev = $0; gsub(/PATCHLEVEL.*=/, NIL, plev); } /^SUBLEVEL/ { slev = $0; gsub(/SUBLEVEL.*=/, NIL, slev); } /^EXTRAVERSION/ { ever = $0; gsub(/EXTRAVERSION.*=/, NIL, ever); gsub(/ /, NIL, ever); } END { printf("%d.%d.%d%s", ver, plev, slev, ever); }' %{_kernelsrcdir}/Makefile 2> /dev/null))
d514eecd
ER
288%__kernel_rel %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not")
289%__kernel_rpmvr %(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not")
3241033b 290%_kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}
f62e856d 291%_kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')
87be1cf0 292
e00dd7f6 293# sgml macros
3241033b
ER
294%xmlcat_add() /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
295%xmlcat_del() /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
296%xmlcat_add_rewrite /usr/bin/xmlcatalog --noout --add rewriteSystem
297%xmlcat_create() /usr/bin/xmlcatalog --noout --create %1 ;
298%sgmlcat_add() /usr/bin/install-catalog --add %1 %2 > /dev/null ;
299%sgmlcat_del() /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
e00dd7f6 300%docbook_sgmlcat_fix() { for l in \
301'' \
302' -- default decl --' \
303'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
304' -- hacks for opensp --' \
305'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
306'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
307'' \
308; do echo $l; done >> %1 \
309}
310
eea64748
ER
311# vim - "
312
4f044018
ER
313# minimum file size needed for compressed documents.
314# just smaller files than this get larger when compressed.
a88ae20f
ER
315# some stats:
316# - 0 byte file compressed was 25 bytes .gz
317# - 39 byte file was compressed as 57
318# - with test/test.spec@man 158 byte file was compressed also 158
319%_min_compress_bytes 159
4f044018 320
9c404149
AM
321#-----------------------------------------------------------------
322# find and gzip all files in %{_mandir} and %{infodir}
323#
324# Requires: xargs, find
325#
326#%no_install_post_compress_docs 1
327%__spec_install_post_compress_docs { \
53d5af13 328%{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
4e10ec06 329 for i in /usr/share/man /usr/X11R6/man; do \
9c404149 330 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
4e10ec06 331 echo "Compress man pages: $i"; \
4f044018
ER
332 find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
333 find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
6375241c
ER
334 find $RPM_BUILD_ROOT$i -type l | while read a; do \
335 m=$(readlink $a); \
336 rm -f $a; \
337 echo .so ${m##*/} > $a; \
338 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
339 done; \
4f044018 340 find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
9c404149
AM
341 fi; \
342 done; \
728ad671
JB
343 if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
344 echo "Compress info pages: %{_infodir}"; \
345 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
346 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
347 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
4e10ec06 348 fi; \
53d5af13 349}; __spec_install_post_compress_docs } }
9c404149
AM
350
351#-----------------------------------------------------------------
352# Strip executable binaries and shared object files
353#
354# Requires: find, awk, strip, cut, xargs
355#
a2ad2754
JB
356# Special macros which affect this process:
357#%no_install_post_strip 1 # disable stripping at all
358#%_noautostrip regexp # exclude files matching (anchored!) regex from stripping
359#%_autostripall regexp # strip files matching (anchored!) regex using plain strip
360#%_autostripunneeded regexp # strip files matching (anchored!) regex using strip --strip-unneeded
361#%_autostripdebug regexp # strip files matching (anchored!) regex using strip --strip-debug
362#
9c404149 363%__spec_install_post_strip {%{!?debug: \
53d5af13 364%{!?no_install_post_strip:__spec_install_post_strip() { \
98a06bad 365if [ -d "$RPM_BUILD_ROOT" ]; then \
eea64748
ER
366 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
367 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
368 if [ "$modulelist" ]; then \
369 modulecount=$(echo "$modulelist" | wc -l); \
737fefdc 370 printf "Stripping %d kernel modules..." $modulecount; \
3df8db34
ER
371 echo "$modulelist" | xargs -l512 chmod u+w; \
372 echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
373 echo "DONE"; \
374 fi; \
eea64748 375 fi; \
0ac49134 376 filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
f89ccb5f
JB
377 if [ -n "$filelist" ]; then \
378 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
379 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
380 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
a2ad2754 381 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
f89ccb5f 382 if [ -n "$elfexelist" ]; then \
4d5370ac 383 printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
f89ccb5f
JB
384 chmod u+w $elfexelist; \
385 %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
386 echo "DONE"; \
387 fi; \
388 if [ -n "$elfsharedlist" ]; then \
4d5370ac 389 printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
f89ccb5f
JB
390 chmod u+w $elfsharedlist; \
391 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
392 echo "DONE"; \
393 fi; \
394 if [ -n "$archiveslist" ]; then \
4d5370ac 395 printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
f89ccb5f
JB
396 chmod u+w $archiveslist; \
397 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
398 echo "DONE"; \
399 fi; \
98a06bad 400 fi; \
0ac49134
ER
401 filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
402 filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
403 filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
f89ccb5f 404 if [ -n "$filelist_all" ]; then \
4d5370ac 405 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
a2ad2754 406 chmod u+w $filelist_all; \
f89ccb5f 407 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
322f84b9 408 echo "DONE"; \
9c404149 409 fi; \
f89ccb5f 410 if [ -n "$filelist_unneeded" ]; then \
4d5370ac 411 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
a2ad2754 412 chmod u+w $filelist_unneeded; \
f89ccb5f 413 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
322f84b9 414 echo "DONE"; \
8f74418b 415 fi; \
f89ccb5f 416 if [ -n "$filelist_debug" ]; then \
4d5370ac 417 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
a2ad2754 418 chmod u+w $filelist_debug; \
f89ccb5f 419 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
322f84b9 420 echo "DONE"; \
9f0d4f36 421 fi; \
53d5af13 422fi; }; __spec_install_post_strip } } }
3241033b 423
fc5d7e20 424#-----------------------------------------------------------------
425# remove all RPATH from executable binaries and shared object files
426#
427# Requires: find, awk, cut, xargs, chrpath, uname
428#
a2ad2754
JB
429# Special macros which affect this process
430#%no_install_post_chrpath 1 # disable chrpath at all
431#%_noautochrpath regex # exclude files matching (anchored!) regex from chrpath
432#
fc5d7e20 433%__spec_install_post_chrpath {%{!?debug: \
53d5af13 434%{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
9f0d4f36 435if [ -d "$RPM_BUILD_ROOT" ]; then \
0ac49134 436 files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
98a06bad 437 if [ -n "$files" ]; then \
d5517264 438 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
3401a2cd 439 fi; \
98a06bad 440 if [ -n "$objs" ]; then \
4d5370ac 441 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
98a06bad
ER
442 echo "$objs" | \
443 while read file; do \
444 rpath= ; \
445 chmod u+w "$file"; \
446 for dir in `chrpath -l "$file" | \
447 awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'` ; do \
448 case $dir in \
449 /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
450 echo "remove-rpath: $dir in $file"; \
451 ;; \
452 * ) \
453 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
454 else rpath="$rpath:$dir" ; fi ; \
455 ;; \
456 esac ; \
457 done ; \
458 if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
459 else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
460 done; \
461 fi; \
53d5af13 462fi; }; __spec_install_post_chrpath } } }
3241033b 463
d72c185f 464#-----------------------------------------------------------------
ccb8ae8d 465# Find and gzip all kernel modules
466#
467# Requires: find
468#
fe6c4bdd 469#%no_install_post_compress_modules 1
ccb8ae8d 470%__spec_install_post_compress_modules { \
53d5af13 471%{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
f3bfe4ac 472 if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
f3bfe4ac 473 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
4d5370ac
ER
474 if [ "$q" ]; then \
475 printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
476 echo "$q" | xargs -r %{__gzip} -9nf; \
477 echo "DONE"; \
478 find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
479 while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
480 fi; \
3241033b 481 fi; \
53d5af13 482}; __spec_install_post_compress_modules } }
9c404149 483
ef64802f
ER
484# Remove common Perl files we don't package
485%__spec_install_post_perl_clean {\
486%{!?no_install_post_perl_clean: \
487%{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
488} }
489
83094b62 490#-----------------------------------------------------------------
0e4cb4dd 491# Update GConf2 schemas
83094b62 492#
493# Requires: GConf2
494#
46885239 495%gconf_schema_install() \
3241033b 496 umask 022; \
f27cf2fd
ER
497 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
498%{nil}
46885239 499
500%gconf_schema_uninstall() \
f93109a0 501if [ $1 = 0 ]; then \
3241033b
ER
502 umask 022; \
503 GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
f27cf2fd 504fi; \
f93109a0 505%{nil}
506
507#-----------------------------------------------------------------
508# Update desktop MIME database
c0a4caa0 509# requires: desktop-file-utils
f93109a0 510#
f27cf2fd 511%update_desktop_database_post() \
f93109a0 512 umask 022; \
fb59e475 513 /usr/bin/update-desktop-database -q; \
f6722c78 514%{nil}
f93109a0 515
f27cf2fd
ER
516%update_desktop_database_postun() \
517if [ "$1" = "0" ]; then \
f93109a0 518 umask 022; \
fb59e475 519 /usr/bin/update-desktop-database -q; \
f27cf2fd 520fi; \
f6722c78 521%{nil}
f93109a0 522
fb59e475 523#-----------------------------------------------------------------
524# Update shared MIME info database
525# requires: shared-mime-info
526#
f27cf2fd 527%update_mime_database() \
fb59e475 528 umask 022; \
529 /usr/bin/update-mime-database %{_datadir}/mime; \
f6722c78 530%{nil}
fb59e475 531
532#-----------------------------------------------------------------
533# Update icon cache
534# requires: gtk+
535#
f27cf2fd 536%update_icon_cache() \
fb59e475 537 umask 022; \
072f4b80 538 /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
f6722c78 539%{nil}
fb59e475 540
f93109a0 541#-----------------------------------------------------------------
542# Update scrollkeeper database
543# requires: scrollkeeper
544#
545%scrollkeeper_update_post() \
f93109a0 546 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 547%{nil}
f93109a0 548
549%scrollkeeper_update_postun() \
f27cf2fd 550if [ "$1" = "0" ]; then \
f93109a0 551 /usr/bin/scrollkeeper-update -q; \
f27cf2fd 552fi; \
f93109a0 553%{nil}
554
9c404149
AM
555#-----------------------------------------------------------------
556# post %install sequence:
557# - autodeps exceptions
558# - compress all man and info pages,
559# - strip all ELF executables and ELF shared objects if not %debug.
8f74418b 560# - compress kernel modules if any
9c404149
AM
561
562###################################################################
563# Requires/Provides automation
564# exceptions system by Jacek Konieczny <jajcus@pld.org.pl>
338726a6 565#
2892b5df
JB
566%__noautoreqfiles %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
567%__noautoprovfiles %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
568%__noautoreq %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
569%__noautoreqdep %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
570%__noautoprov %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
338726a6
JB
571#%_noautocompressdoc %{nil}
572#
8f74418b
MM
573%_missing_doc_files_terminate_build 1%{nil}
574%_unpackaged_files_terminate_build %{nil}
8781dc74 575# (X)emacs support
d77dcb61 576%___emacs_lispdir_helper -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
8781dc74
AF
577%_emacs_lispdir %(emacs %___emacs_lispdir_helper)
578%_xemacs_lispdir %(xemacs %___emacs_lispdir_helper)
25043cd4 579
02b58f60
JK
580%__php_provides %{nil}
581%__php_requires %{nil}
582%__perl_provides %{nil}
583%__perl_requires %{nil}
fa3497cd 584%__mono_provides %{nil}
585%__mono_requires %{nil}
25043cd4
AF
586
587# Perl specific macro definitions.
34f59add
ER
588%perl_privlib %(eval "`%{__perl} -V:installprivlib`"; echo $installprivlib)
589%perl_archlib %(eval "`%{__perl} -V:installarchlib`"; echo $installarchlib)
590%perl_vendorlib %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
c853f847 591%perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)
34f59add
ER
592%perl_sitelib %(eval "`%{__perl} -V:installsitelib`"; echo $installsitelib)
593%perl_sitearch %(eval "`%{__perl} -V:installsitearch`"; echo $installsitearch)
25043cd4 594
45c00b39 595# Ruby
c5472d67 596%ruby_archdir %(ruby -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)
7ccf7643 597%ruby_ridir %(ruby -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)
c5472d67 598%ruby_rubylibdir %(ruby -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)
82674554 599%ruby_vendorarchdir %(ruby -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)
600%ruby_vendorlibdir %(ruby -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)
c5472d67
ER
601%ruby_sitearchdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)
602%ruby_sitelibdir %(ruby -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)
603%ruby_version %(ruby -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)
669604db
ER
604%ruby_ver_requires_eq Requires: ruby(ver) = %ruby_version
605%ruby_mod_ver_requires_eq Requires: ruby-modules(ver) = %ruby_version
45c00b39 606
7ccf7643 607%php_pear_dir /usr/share/pear
89f5bf64 608%php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)
92fd8408 609%php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)
586429ee 610%php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)
25043cd4 611
0c5d1b9b 612# extract php/zend api versions
586429ee
ER
613%php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)
614%php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)
615%php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)
616%php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)
617%zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)
618%zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)
619%zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})
c1b2705c
ER
620
621# helper macro
f952c0f3 622%__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
c1b2705c
ER
623
624# macros for public use
625# for php extensions (php-pecl)
68b68193 626%requires_php_extension %{__php_api_requires modules_api php_api_version} \
415f4a1a 627%{__php_api_requires zend_module_api} \
f952c0f3
ER
628%{__php_api_requires -v %php_major_version debug php_debug} \
629%{__php_api_requires -v %php_major_version thread-safety zend_zts}
68b68193 630
c1b2705c
ER
631# for zend extensions
632%requires_zend_extension %{__php_api_requires zend_module_api} \
68b68193 633%{__php_api_requires zend_extension_api} \
f952c0f3
ER
634%{__php_api_requires -v %php_major_version debug php_debug} \
635%{__php_api_requires -v %php_major_version thread-safety zend_zts}
c1b2705c 636
934c685f
ER
637# for php pdo modules (php-pecl-PDO_*)
638%requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
639
6c3b8203
ER
640# for using PHP post scripts. for PHP >= 5.0
641%php_webserver_restart \
642[ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
578e7794 643[ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
ba1800dc
ER
644if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
645 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
646 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
647 %service -q php-fcgi restart \
648 fi \
649fi \
6c3b8203
ER
650%{nil}
651
652# for using php post scripts. for PHP >= 4.0 && PHP < 5.0
653%php4_webserver_restart \
654[ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
578e7794 655[ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
ba1800dc
ER
656if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
657 PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
658 if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
659 %service -q php-fcgi restart \
660 fi \
661fi \
6c3b8203
ER
662%{nil}
663
578e9248
AM
664
665# X.org helper macros
40c78bc0 666%__xorg_abi_requires() Requires: xorg-xserver-server(%{expand:%1}-abi) = %{expand:%{%{!?2:%{1}}%{?2}}}
578e9248 667#
12cd65b1
AM
668%xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
669%xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
670%xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)
671%xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
672%xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)
578e9248
AM
673
674%requires_xorg_xserver_extension %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
675%{__xorg_abi_requires extension xorg_xserver_extension_abi}
676%requires_xorg_xserver_xinput %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
677%{__xorg_abi_requires xinput xorg_xserver_xinput_abi}
678%requires_xorg_xserver_font %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
679%{__xorg_abi_requires font xorg_xserver_font_abi}
680%requires_xorg_xserver_videodrv %{__xorg_abi_requires ansic xorg_xserver_ansic_abi} \
681%{__xorg_abi_requires videodrv xorg_xserver_videodrv_abi}
682
25043cd4
AF
683# Python specific macro definitions.
684# python main version
7ccf7643 685%py_ver %(python -c "import sys; print sys.version[:3]")
25043cd4
AF
686
687# directories
3241033b
ER
688%py_prefix %(python -c "import sys; print sys.prefix")
689%py_libdir %{py_prefix}/%{_lib}/python%{py_ver}
ef7ec0a8 690%py_scriptdir %{py_prefix}/share/python%{py_ver}
3241033b 691%py_incdir /usr/include/python%{py_ver}
7ccf7643 692%py_sitedir %{py_libdir}/site-packages
ef7ec0a8 693%py_sitescriptdir %{py_scriptdir}/site-packages
3241033b 694%py_dyndir %{py_libdir}/lib-dynload
25043cd4
AF
695
696# pure python modules compilation
3241033b 697%py_comp python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4 698
3241033b 699%py_ocomp python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
25043cd4
AF
700
701# Software written in Python language require Python with main version
e63cd81d 702%pyrequires_eq() Requires: %1
25043cd4 703
f12c2314
AF
704# Hardlink binary identical .pyc and .pyo files
705# (idea by glen <at> pld-linux <dot> org)
706%__spec_install_post_py_hardlink {\
53d5af13 707%{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
f12c2314 708[ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
83f0d22e 709 b="${a%.pyc}.pyo"; \
f12c2314
AF
710 if cmp -s "$a" "$b"; then \
711 ln -f "$a" "$b"; \
712 fi; \
713done \
53d5af13 714}; __spec_install_post_py_hardlink } }
f12c2314 715
9227b3f9 716# remove python sources, so that check-files won't complain
f12c2314
AF
717# (idea by glen <at> pld-linux <dot> org)
718%py_postclean() \
0f82e280 719for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
820792a9 720 [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
f12c2314
AF
721done \
722%{nil}
723
0fc5cff8 724# depmod macro
725%depmod() { \
f6148427 726umask 022; \
0fc5cff8 727if [ -e /boot/System.map-%1 ]; then \
3241033b 728 /sbin/depmod -a -F /boot/System.map-%1 %1; \
0fc5cff8 729else \
3241033b
ER
730 if [ -e /boot/System.map ]; then \
731 /sbin/depmod -a -F /boot/System.map %1; \
732 else \
733 /sbin/depmod -a %1; \
734 fi \
0fc5cff8 735fi; \
736}
737
2afc6e64 738# XMMS specific macros
3241033b
ER
739%xmms_prefix %(xmms-config --prefix 2>/dev/null)
740%xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null)
741%xmms_version %(xmms-config --version 2>/dev/null)
742%xmms_datadir %(xmms-config --data-dir 2>/dev/null)
743%xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null)
744%xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null)
745%xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null)
746%xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null)
747%xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null)
748%xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null)
2afc6e64 749
d1537778
PS
750%_target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')
751
848c0d68 752# user/group checking macros
753#
754# Usage:
755# %userremove myuser
756#
757%userremove /usr/lib/rpm/user_group.sh user del
758%groupremove /usr/lib/rpm/user_group.sh group del
759#
760# Usage:
761# if %usertestrm myuser; then
762# /usr/sbin/userdel -r myuser
763# Note:
764# use these macros only if you need to call userdel/groupdel with
765# a non-standard option or take an extra action; otherwise use the
766# %userremove/%groupremove macros
767#
768%usertestrm /usr/lib/rpm/user_group.sh user testrm
769%grouptestrm /usr/lib/rpm/user_group.sh group testrm
08d9b1f6
JK
770# user group membership management macros
771#
772# Usage:
773# %addusertogroup myuser agroup
774#
775%addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
72fcfcb3 776
777# banner support (useful in {pre,post}{,un} and triggers)
778#
779# Usage:
aa41c920 780# %banner name [-a] [-e] [-n] [-tn] <<EOF
72fcfcb3 781# the banner text, the banner text
aa41c920
ER
782# the banner text, and following line
783#EOF
784# You can use any form of here-document, <<'EOF' <<-EOT will do.
785# NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
786#
72fcfcb3 787# -a - append to the banner
a8b9562a 788# -e - send to stderr instead of stdout
628754cb 789# -n - no show banner (overrides -t)
790# -t - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
276a7b45
ER
791#
792# Tests:
793# (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
794# rpm -E 'date | %banner -e banner' > m; sh -x m
795#
afb54f6c 796%banner(aent:) ( \
1b334fe4 797RPM_SCRIPTVERBOSITY=5 \
798[ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
799if [ -x /usr/bin/banner.sh ]; then \
aa41c920 800 CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
1b334fe4 801else \
a8b9562a 802 CMD="cat%{-e: >&2}" \
1b334fe4 803fi \
276a7b45
ER
804eval $CMD %{?2:%2}%{?3: %3}) \
805%{nil}
628754cb 806
990bd03f 807# useradd/groupadd macros
4c73bc69 808# Author: Elan Ruusamäe <glen@pld-linux.org>
90627280
ER
809#
810# Usage:
811# %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
812# [-g initial_group] [-G group[,...]] login
813#
814# -u uid. REQUIRED
815# -g gid/group. REQUIRED
816# -s defaults to /bin/false
817# -d defaults to /usr/share/empty
818# -c No default
819# -r is accepted but ignored (it's always set)
6bd4c218 820# -k skeleton dir. defaults to /usr/share/empty
90627280
ER
821# rpm specific flags
822# -P package name. defaults to %{name}
823#
90627280 824%useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
9ba02ba9
ER
825%{!-u:%{error:useradd: Required argument -u missing}} \
826%{!-g:%{error:useradd: Required argument -g missing}} \
827%{!?1:%{error:useradd: Required parameter login missing}} \
90627280
ER
828if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
829 if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
830 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
831 exit 1 \
832 fi \
833else \
834 echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
835 /usr/sbin/useradd \\\
b5a7d552 836 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
90627280
ER
837 -u %{-u*} \\\
838 -r \\\
839 -d %{-d*}%{!-d:/usr/share/empty} \\\
840 -s %{-s*}%{!-s:/bin/false} \\\
840e7b00 841 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
90627280
ER
842 -g %{-g*} \\\
843 %{-M} \\\
844 %{-G:-G %{-G*}} \\\
1aac682a 845 %{expand:%{%{#}}} 1>&2 || exit $? \
bcf63b58 846 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
90627280
ER
847fi;
848
90627280
ER
849# Usage:
850# %groupadd [-P package] [-g gid] group
851#
852# -g gid. REQUIRED
853#
854# Sample:
855# %groupadd -P %{name}-base -g %{gid} %{name}
856
857%groupadd(g:P:rfo) \
9ba02ba9
ER
858%{!-g:%{error:groupadd: Required argument -g missing}} \
859%{!?1:%{error:groupadd: Required parameter group missing}} \
90627280
ER
860if [ -n "`/usr/bin/getgid %{1}`" ]; then \
861 if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
862 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
863 exit 1 \
864 fi \
865else \
866 echo "Adding group %{1} GID=%{-g*}." \
1aac682a 867 /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
bcf63b58 868 [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
90627280 869fi;
7cb77741 870
7c50f037 871# webapp macros
4c73bc69 872# Author: Elan Ruusamäe <glen@pld-linux.org>
35663282
ER
873#
874# The config is installed/removed inside trigger, this means that you can any
875# time install apache1/apache/lighttpd package and the configuration file is
fe6c4bdd 876# updated. if you don't need the config for various reason for specific
35663282
ER
877# webserver, just remove the symlink from config directory using webapp
878# program. the trigger will not recreate the symlink on upgrades. In other
879# words the config is linked to webserver config directory on first install of
880# PACKAGE or WEBSERVER.
881#
7c50f037
ER
882# Add package's webserver config to webserver webapps dir.
883# Usage:
df979130 884# %webapp_register WEBSERVER WEBAPP
35663282
ER
885#
886%webapp_register() \
887%{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
888if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
889 /usr/sbin/webapp register %1 %2\
890fi\
694a8f2e 891# reload webserver if the config symlink is there and skip reload if webserver is upgraded\
5d3a09a3 892if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
16897aea 893 %{expand:%service -q %%1 reload}\
35663282
ER
894fi\
895%{nil}
896
897# Remove package's config from webserver webapps dir.
35663282 898# Usage:
531c0efc
ER
899# %webapp_register [-f] WEBSERVER WEBAPP
900%webapp_unregister(f) \
35663282
ER
901%{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
902# remove link if either of the packages are gone \
5d3a09a3 903if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
df979130 904 /usr/sbin/webapp unregister %1 %2\
16897aea 905 %{expand:%service -q %%1 reload}\
35663282
ER
906fi \
907%{nil}
908
462b26fa 909# service macro.
4c73bc69 910# Author: Elan Ruusamäe <glen@pld-linux.org>
462b26fa
ER
911#
912# calls usual service restart on package %post, but skips the restart if
913# administrator has disabled automatic service restarts in either global
914# /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
915#
462b26fa 916# Usage:
3e913a30 917# %service [-q] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
462b26fa 918#
a0bbe604 919# -q be silent when service isn't started (for scriplets restaring other package's services)
462b26fa 920#
8b781cff 921%service(q) {{%(export quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
6aedae62
ER
922
923
f9aa75bf
ER
924# Java macros. based on jpackage macros.java
925#
926# Root directory where all Java VMs/SDK/JREs are installed.
2d4659a1 927%_jvmdir %{_libdir}/jvm
f9aa75bf
ER
928
929# Root directory where all Java VMs/SDK/JREs expose their jars
2d4659a1 930%_jvmjardir %{_libdir}/jvm-exports
f9aa75bf
ER
931
932# Root directory for all Java VM/SDK/JRE's private things.
933%_jvmprivdir %{_libdir}/jvm-private
934
935# Root directory for all architecture dependent parts of Java VM/SDK/JRE's
2d4659a1 936%_jvmlibdir %{_libdir}/jvm
f9aa75bf
ER
937
938# Root directory for all architecture independent parts of Java VM/SDK/JRE's
939%_jvmdatadir %{_datadir}/jvm
940
941# Root directory for all configurations parts of Java VM/SDK/JRE's
942%_jvmsysconfdir %{_sysconfdir}/jvm
943
944# Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
f5ed4276 945%_jvmcommonlibdir %{_libdir}/jvm-common
f9aa75bf
ER
946
947# Root directory for all common architecture independent parts of Java VM/SDK/JRE's
f5ed4276 948%_jvmcommondatadir %{_datadir}/jvm-common
f9aa75bf
ER
949
950# Root directory for all common configurations parts of Java VM/SDK/JRE's
f5ed4276 951%_jvmcommonsysconfdir %{_sysconfdir}/jvm-common
f9aa75bf
ER
952
953# Directory where arch-specific (JNI) version-independent jars are installed.
2d4659a1 954%_jnidir %{_libdir}/java
f9aa75bf 955
435c9ec7 956%java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})
6aedae62 957
fe6c4bdd
ER
958%ant JAVA_HOME=%{java_home} ant
959%jar %{java_home}/bin/jar
435c9ec7 960%java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)
fe6c4bdd
ER
961%javac %{java_home}/bin/javac
962%javadoc %{java_home}/bin/javadoc
6aedae62 963
fe6c4bdd 964%add_jvm_extension JAVA_LIBDIR=%{buildroot}/%{_javadir} %{_bindir}/jvmjar -l
6aedae62
ER
965
966%jpackage_script() \
3ca65b87
ER
967install -d $RPM_BUILD_ROOT%{_bindir}\
968cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
6aedae62
ER
969#!/bin/sh\
970#\
971# %{name} script\
972# JPackage Project <http://www.jpackage.org/>\
973\
974# Source functions library\
975. %{_javadir}-utils/java-functions\
976\
977# Source system prefs\
3ca65b87 978if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
fe6c4bdd 979 . %{_sysconfdir}/java/%{name}.conf\
6aedae62
ER
980fi\
981\
982# Source user prefs\
3ca65b87
ER
983if [ -f $HOME/.%{name}rc ]; then\
984 . $HOME/.%{name}rc\
6aedae62
ER
985fi\
986\
987# Configuration\
988MAIN_CLASS=%1\
989BASE_FLAGS=%2\
990BASE_OPTIONS=%3\
3ca65b87 991BASE_JARS="%(echo %4 | tr ':' ' ')"\
6aedae62
ER
992\
993# Set parameters\
994set_jvm\
3ca65b87
ER
995set_classpath $BASE_JARS\
996set_flags $BASE_FLAGS\
997set_options $BASE_OPTIONS\
6aedae62
ER
998\
999# Let's start\
3ca65b87 1000run "$@"\
6aedae62
ER
1001EOF
1002
06f11871
ER
1003# jpackage 1.7
1004# Directory for maven depmaps
1005#
1006%_mavendepmapdir /etc/maven
1007%_mavendepmapfragdir /etc/maven/fragments
1008
1009#
1010# add_to_depmap adds an entry to the depmap. The arguments are:
1011#
1012# %1 the original groupid
1013# %2 the original artifact id
1014# %3 the version
1015# %4 the new groupid
1016# %5 the new artifactid
1017#
1018
1019%add_to_maven_depmap() \
1020install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1021cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1022<dependency>\
1023 <maven>\
1024 <groupId>%1</groupId>\
1025 <artifactId>%2</artifactId>\
1026 <version>%3</version>\
1027 </maven>\
1028 <jpp>\
1029 <groupId>%4</groupId>\
1030 <artifactId>%5</artifactId>\
1031 <version>%3</version>\
1032 </jpp>\
1033</dependency>\
1034\
1035EOF\
1036%{nil}
1037
1038#==============================================================================
1039#
1040# update_maven_depmap updates the main maven depmap
1041#
1042%update_maven_depmap() \
1043echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1044if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1045cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1046fi\
1047echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1048
1049
59d3ebe9 1050# PEAR install macros
4c73bc69 1051# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1052#
1053# Usage:
1054# %%pear_package_setup [-a #] [-n FMT]
1055#
59d3ebe9 1056# -a # - also unpack SOURCE#. for PEAR bootstrapping
dfce8b19 1057# -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
59d3ebe9 1058# -z - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
dfce8b19
ER
1059#
1060# unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1061# destination hierarchy. you should copy the tree to buildroot after
1062# patching/reorganizing with %%pear_package_install.
1063#
1064# additionally BUILDROOT is stripped from files and files are converted to UNIX
1065# line endings.
1066#
1067# the pear install process output is recorded to install.log, you should put it
8763f51e 1068# to %%doc for later debug or just for information.
dfce8b19
ER
1069#
1070# additionally additional-packages.txt is produced if it was detected that the
1071# package has optional dependencies. the file format is suitable of displaying
1072# in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1073# automatically added for this file.
59d3ebe9
ER
1074
1075
1076# records install.log and transforms PEAR names to PLD Linux rpm package names.
1077%__pear_install_log \
1078tee install.log \
1079# make post message of optional packages \
1080grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1081if [ -s optional-packages.txt ]; then \
1082 awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1083else \
1084 rm -f optional-packages.txt \
1085fi \
1086%{nil}
1087
1088# command invoking pear cli
1089%__pear /usr/bin/pear
1090
67a089ff 1091%pear_install(a:n:zD) \
59d3ebe9
ER
1092%__pear \\\
1093 -c pearrc \\\
dfce8b19
ER
1094 -d doc_dir=/docs \\\
1095 -d php_dir=%{php_pear_dir} \\\
1096 -d bin_dir=%{_bindir} \\\
1097 -d data_dir=%{php_pear_dir}/data \\\
1098 -d test_dir=%{php_pear_dir}/tests \\\
1099 install \\\
59d3ebe9 1100 --packagingroot=%{builddir} \\\
dfce8b19
ER
1101 --offline \\\
1102 --nodeps \\\
1103 %{-f:--force} \\\
67a089ff
ER
1104 %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1105%{nil}
1106
1107# The main macro.
1108# using this macro will append optional-packages.txt to the nocompressdoc list
1109# as it's displayed to user after package install. and adding additional gzip
1110# dep is just waste ;)
1111%pear_package_setup(a:n:zD) \
1112%define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1113%define builddir %{_builddir}/%{srcdir} \
1114%setup -q -c -T %{-D:-D} -n %{srcdir} \
1115%{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1116%{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1117%pear_install \
59d3ebe9
ER
1118%{-z:cd ..} \
1119cat %{-z:$_N/}.install.log | %__pear_install_log \
1120\
dfce8b19 1121# undos sources \
2a80e4cf 1122find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
dfce8b19
ER
1123%{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1124%{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1125%{nil}
1126
7bef60e8 1127# Copies exctracted PEAR package structure and PEAR registry to buildroot.
4c73bc69 1128# Author: Elan Ruusamäe <glen@pld-linux.org>
dfce8b19
ER
1129%pear_package_install() \
1130cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1131find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1132# help the developer out a little: \
1133if [ -f _noautoreq ]; then \
1134 echo "AutoReqdep detected:" \
1135 echo "_noautoreq $(cat _noautoreq)" \
1136fi \
1137%{nil}
1138
0d5dd00c
ER
1139
1140# Register OpenLDAP schema.
4c73bc69 1141# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1142#
1143# Usage:
1144# %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1145#
1146# -d specify dependant schemas, separated by comma
1147#
1148%openldap_schema_register(d:) \
1149for schema in %*; do \
1150 if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1151 %{__sed} -i -e " \
1152 /^include.*local.schema/{ \
1153 iinclude\\t $schema\
1154 } \
1155 " /etc/openldap/slapd.conf \
1156 fi \
1157done \
1158# enable dependant schemas \
1159if [ "%{-d*}" ]; then \
1160 %{__sed} -i -e ' \
1161 /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1162 s/^#// \
1163 }' /etc/openldap/slapd.conf \
1164fi \
1165%{nil}
1166
1167# Unregister OpenLDAP schema.
4c73bc69 1168# Author: Elan Ruusamäe <glen@pld-linux.org>
0d5dd00c
ER
1169#
1170# Usage:
1171# %%openldap_schema_unregister %{schemadir}/horde.schema
1172#
1173%openldap_schema_unregister() \
1174for schema in %*; do \
1175 if grep -q "$schema" /etc/openldap/slapd.conf; then \
1176 %{__sed} -i -e " \
1177 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1178 # for symmetry it would be nice if we disable enabled schemas in post, \
1179 # but we really can not do that, it would break something else. \
1180 " /etc/openldap/slapd.conf \
1181 fi \
1182done \
1183%{nil}
1184
b0bc2936 1185%env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
d834e0a1 1186
dcc6baf7 1187
1188# Build modules for kernels 2.6
1189# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1190#
1191# Usage:
aa559e46 1192# %build_kernel_modules -m <modules> -C <directory>
dcc6baf7 1193#
1194# remember that proper Makefile is still required
1195# Options:
990bd03f 1196# -m <modules> (required) -- comma-separated list of modules to save,
dcc6baf7 1197# without .ko extension, may be placed in subdirectory
aa559e46 1198# -C <directory> -- change to <directory> before doing anything
dcc6baf7 1199# -p <arg>, -P <arg> -- arguments passeed to make scripts
5a81d83e 1200# -c -- do not execute make clean
dcc6baf7 1201# <additional arguments> -- all additional arguments will be passed to
1202# make modules
1203#
1204# Additional patching supported via here document. Try:
1205# %build_kernel_modules -m module <<'EOF'
1206# your patch script here
1207# EOF
1208# Don't use it unless patching depends on config options.
1209
1210# Developer note: don't touch it unless you know how to handle '\'.
1211# - \ in script expands to nothing
1212# - \\\ in script expands to \
566398b4 1213# - \\\ inside definition expands to nothing
dcc6baf7 1214# - \\\\\\\ inside definition expands to \
1215# - in last line \ has to touch arguments so arguments passing
1216# in new lines (using \) will be supported
1217
5a81d83e 1218%build_kernel_modules(p:P:m:C:c) \
dcc6baf7 1219%{!?-m:%{error:%{0}: Required module name/list missing} exit 1} \
1220 \
1221%define Opts \\\\\\\
1222%if "%{_target_base_arch}" != "%{_arch}" \\\
1223 %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386" \\\
88608ef7 1224 CC="%{kgcc}" ARCH=%{_target_base_arch} \\\
dcc6baf7 1225 %else \\\
1226 ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1227 %endif \\\
1228%else \\\
88608ef7 1229 CC="%{kgcc}" \\\
dcc6baf7 1230%endif \
88608ef7 1231%define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
dcc6baf7 1232 O=$PWD/o %{?with_verbose:V=1} %{Opts} \
1233 \
e364bc26 1234%{?-C:cd %{-C*}} \
dcc6baf7 1235compile() { \
1236 L="<"; [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)" \
1237 set -e -x \
730239f9 1238 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1239 \
730239f9 1240for cfg in ${cfgs:-dist}; do \
dcc6baf7 1241 [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1 \
1242 \
c546f6fb 1243 rm -rf o \
dcc6baf7 1244 install -d o/include/linux \
1245 ln -sf %{_kernelsrcdir}/config-$cfg o/.config \
1246 ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers \
1247 ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1248 \
1249 set +x \
1250 [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell \
1251 set -x \
1252 \
1253 %if %{with dist_kernel} \
1254 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts \\\
1255 %{-p*} %{-P*} \\\
1256 %{MakeOpts} \
1257 %else \
1258 install -d o/include/config \
1259 touch o/include/config/MARKER \
1260 ln -sf %{_kernelsrcdir}/scripts o/scripts \
1261 %endif \
1262 \
5a81d83e 1263 %{!?-c:%{__make} -C %{_kernelsrcdir} clean \\\
dcc6baf7 1264 RCS_FIND_IGNORE="-name '*.ko' -o" \\\
5a81d83e 1265 M=$PWD %{MakeOpts}} \
dcc6baf7 1266 %{__make} -C %{_kernelsrcdir} modules \\\
1267 ${1+"$@"} \\\
1268 M=$PWD %{MakeOpts} \
1269 \
1270 for MODULE in {%{-m*},}; do \
1271 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko \
1272 done \
1273done \
aa559e46 1274%{?-C:cd -} \
dcc6baf7 1275} \
1276compile %{*}\
1277%{nil}
1278
1279
1280# Install kernel modules built by %build_kernel_modules
1281# Author: Przemyslaw Iskra <sparky@pld-linux.org>
1282#
1283# Usage:
1284# %install_kernel_modules -m <modules> -d <directory>
1285#
1286# Options:
990bd03f 1287# -m <modules> (required) -- comma-separated list of modules to install,
dcc6baf7 1288# without .ko extension, may be placed in subdirectory
1289# -d <directory> (required) -- in what subdirectory modules should be
1290# installed (eg. misc, kernel/drivers/net)
1291# -s <suffix> -- suffix to use when installing modules, useful when module
1292# with same name exists in kernel already
1293# -n <file> -- name of modprobe config file to use (without .conf extension)
00395cf1 1294# for defining aliases, only useful with -s
dcc6baf7 1295
1296%install_kernel_modules(m:d:s:n:) \
1297%{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1} \
1298%{!?-d:%{error:%{0}: Required module directory missing}exit 1} \
1299%{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1300 \
1301%define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver} \
1302%define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
412786d1 1303 \
730239f9 1304local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
dcc6baf7 1305 \
1306for MODULE in {%{-m*},}; do \
1307 [ -n "${MODULE}" ] || continue \
730239f9
ER
1308 for cfg in ${cfgs:-dist}; do \
1309 [ "$cfg" = smp ] && suf=smp || suf= \
1310 MNAME=${MODULE##*/} \
1311 install -D ${MODULE}-$cfg.ko \\\
1312 %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko \
b9460afb 1313 %{?-s:install -d %{ModprobeD}$suf \
730239f9
ER
1314 echo "alias ${MNAME} ${MNAME}-%{-s*}" \\\
1315 >> %{ModprobeD}$suf/%{-n*}.conf} \
1316 done \
dcc6baf7 1317done \
1318%{nil}
1319
fa65356c 1320# patchset macros
4c73bc69 1321# Author: Elan Ruusamäe <glen@pld-linux.org>
fa65356c
ER
1322#
1323# Usage:
1324# %patchset_source -f <seq(1) format> <start> [<end>]
1325# %patchset_patch <start> [<end>]
1326#
1327# If <end> is omited, it is assumed to be <start>.
1328#
1329# For example in preamble:
1330# %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1331# and in %prep:
1332# %patchset_patch 33 44
1333
1334# generate SourceX urls from range START STOP
1335# Format can be SINGLE format char of %e, %f, %g, see seq(1)
1336# The sources start from 10000
e91610db 1337%patchset_source(f:b:) %(
44f733ef 1338 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1339 start=$(expr $base + %1);
1340 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1341 # we need to call seq twice as it doesn't allow two formats
1342 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1343 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1344 paste %{tmpdir}/__ps{1,2};
1345 rm -f %{tmpdir}/__ps{1,2};
962f9ecf
ER
1346) \
1347%{nil}
fa65356c
ER
1348
1349# apply sources from %patchset_source
1350# -p specify -pX for %patch line
1351# -b base offset: defaults to 10000
1352%patchset_patch(f:p:b:) %(
44f733ef 1353 base=%{-b*}%{!-b*:10000};
962f9ecf
ER
1354 start=$(expr $base + %1);
1355 end=$(expr $base + %{?2}%{!?2:%{1}});
e91610db
ER
1356 echo ": patchset_patch %1%{?2: to %2}";
1357 seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
962f9ecf
ER
1358) \
1359%{nil}
fa65356c 1360
5730b44b 1361# browser plugins v2
4c73bc69 1362# Author: Elan Ruusamäe <glen@pld-linux.org>
5730b44b
ER
1363#
1364# Usage:
1365# %browser_plugins_add_browser <name> -p <plugindir>
1366#
1367# <name> (required) -- name of the browser. usually %{name}.
1368# -p <plugindir> (required) -- in what directory browser searches for its plugins.
02ebf70f
ER
1369# -b -- default blacklists
1370# -a <arch> override arch
5730b44b
ER
1371#
1372# Example:
1373# %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1374
1375%_browserpluginsconfdir /etc/browser-plugins
5e19a4dc 1376%_browserpluginsdir %{_libdir}/browser-plugins
5730b44b
ER
1377%update_browser_plugins /usr/sbin/update-browser-plugins || :
1378
02ebf70f 1379%browser_plugins_add_browser(p:b:a:) \
9efd458e 1380 browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
5730b44b 1381 install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
02ebf70f
ER
1382 ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1383 blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
5730b44b
ER
1384 echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1385 %{-b:cat >> $blacklist_file %{-b*}} \
1386%{nil}
1387
ad17b654
ER
1388# Helper for LUA.
1389# split string separated by space into quoted list
1390#
4c73bc69 1391# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1392#
1393# %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1394%__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1395
1396# adjust /etc/shells by adding and removing shells from there
4c73bc69 1397# Author: Elan Ruusamäe <glen@pld-linux.org>
ad17b654
ER
1398#
1399# Usage:
1400# %post -p %add_etc_shells -p /bin/sh /bin/pdksh
1401# %preun -p %remove_etc_shells -p /bin/sh /bin/pdksh
1402#
1403# -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1404
1405%add_etc_shells(p) %{-p:<lua>}\
1406t = {}\
1407f = io.open("/etc/shells", "r")\
1408if f then\
1409 for l in f:lines() do t[l]=l; end\
1410 f:close()\
1411end\
1412for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1413 if not t[s] then\
b8c0bc18 1414 print("Adding "..s.." to /etc/shells")\
ad17b654
ER
1415 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1416 end\
1417end\
1418%{nil}
1419
1420%remove_etc_shells(p) %{-p:<lua>}\
b8c0bc18 1421%{-p:if arg[2] == 0 then}\
750e19f4
ER
1422 t = {}\
1423 f = io.open("/etc/shells", "r")\
1424 if f then\
1425 for l in f:lines() do t[l]=l; end\
1426 f:close()\
1427 end\
1428 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
b8c0bc18 1429 print("Removing "..l.." from /etc/shells")\
750e19f4
ER
1430 t[l] = nil\
1431 end\
1432 s=""\
1433 for _, l in pairs(t) do\
1434 s=s..l.."\\n"\
1435 end\
1436 io.open("/etc/shells", "w"):write(s)\
1437%{-p:end} \
ad17b654
ER
1438%{nil}
1439
59d3ebe9 1440# vim:ts=4 sw=4 noet syn=spec
This page took 0.429329 seconds and 4 git commands to generate.